;=============================================================================
; Macros and other preprocessor constants
;=============================================================================

%MACRO avs_mangle 1
    %IFDEF PREFIXED_SYMBOL
        global _%1
        %DEFINE %1 _%1
    %ELSE
        global %1
    %ENDIF
%ENDMACRO

;=============================================================================
; Contants
;=============================================================================

SECTION .rodata:
ALIGN 16

AVS_WORD_1 : TIMES 4 DW 0x0001
AVS_WORD_2 : TIMES 4 DW 0x0002
AVS_WORD_3 : TIMES 4 DW 0x0003
AVS_WORD_4 : TIMES 4 DW 0x0004
AVS_WORD_5 : TIMES 4 DW 0x0005
AVS_WORD_6 : TIMES 4 DW 0x0006
AVS_WORD_7 : TIMES 4 DW 0x0007
AVS_WORD_8 : TIMES 4 DW 0x0008

;=============================================================================
; Optimized multiplying macros
;=============================================================================

%MACRO AVS_MULTIPLY_0 1
   pxor        %1, %1
%ENDMACRO

%MACRO AVS_MULTIPLY_1 1
%ENDMACRO

%MACRO AVS_MULTIPLY_2 1
   psllw       %1, 1
%ENDMACRO

%MACRO AVS_MULTIPLY_3 1
   pmullw      %1, [AVS_WORD_3]
%ENDMACRO
      
%MACRO AVS_MULTIPLY_4 1
   psllw       %1, 2
%ENDMACRO

%MACRO AVS_MULTIPLY_5 1
   pmullw      %1, [AVS_WORD_5]
%ENDMACRO

%MACRO AVS_MULTIPLY_6 1
   pmullw      %1, [AVS_WORD_6]
%ENDMACRO

%MACRO AVS_MULTIPLY_7 1
   pmullw      %1, [AVS_WORD_7]
%ENDMACRO

;=============================================================================
; Stack and function parameters management
;=============================================================================

%DEFINE PARAM(x)    EQU .stack * 4 + x * 4 + .pushcount * 4
%DEFINE PSTACK(x)   EQU x * 4

%MACRO AVS_PUSH 1-*
    %REP %0
        push        %1
        %ROTATE     1
    %ENDREP
%ENDMACRO

%MACRO AVS_POP 1-*
    %REP %0
        %ROTATE     -1
        pop         %1
    %ENDREP
%ENDMACRO

%MACRO AVS_SET_STACK 1-*
    .stack          EQU %1
    .pushcount      EQU %0 - 1
    %XDEFINE        AVS_REGISTERS
    %IF (%0 > 1)
        %XDEFINE    AVS_REGISTERS %2
    %ENDIF
    %IF (%0 > 2)
        %XDEFINE    AVS_REGISTERS AVS_REGISTERS, %3
    %ENDIF
    %IF (%0 > 3)
        %XDEFINE    AVS_REGISTERS AVS_REGISTERS, %4
    %ENDIF
    %IF (%0 > 4)
        %XDEFINE    AVS_REGISTERS AVS_REGISTERS, %5
    %ENDIF
    %IF (%0 > 1)
        AVS_PUSH     AVS_REGISTERS
    %ENDIF
    %IF (%1 > 0)
        sub         esp, .stack * 4
    %ENDIF
%ENDMACRO

%MACRO AVS_REL_STACK 0-1
    %IF (%0 == 0)
         %IF (.stack > 0)
            add         esp, .stack * 4
         %ENDIF
    %ENDIF
    AVS_POP         AVS_REGISTERS
    %UNDEF          AVS_REGISTERS
    ret
%ENDMACRO
